## Contributing Guidelines 📝

We love your input! We want you to make contributing to this simple questions/solutions repository as easy and transparent as possible, whether it's:

- Reporting a bug
- Discussing the current state of the code
- Submitting a fix
- Proposing new features


## Contributing


Different types of contribution practices for this repository - 
#### 1) Add a question and provide the solution for the same
##### *provided question has been addressed earlier, so kindly go through the repository before raising an issue for a question.
- Steps - <br>
  Step a) Click on Issues tab <br>
  Step b) Click on New Issue button <br>
  Step c) Click Get Started button <br>
  Step d) Fill a short description form <br>
  Step e) Press Submit New Issue button <br>
  Step f) Now Comment - "Kindly assign this issue to me" <br>
  Step g) Press on Comment button <br>
  Step h) Wait for the issue to be assigned to you. <br>
  Step i) After the issue get assigned to you. <br>
          You'll also receive my comment stating in which folder the solution needs to be placed as well as the deadline for solution submission. <br>
  Step j) Now you can workout the solution and generate PR(Pull request).
  
#### 2) Provide a solution
- Steps - <br>
  Step a) Click on Issues tab <br>
  Step b) Click on one of the issues which has not been assigned to anyone <br>
  Step c) Read the question description throughly <br>
  Step d) If know are clear with the question description then Comment - "Kindly assign this issue to me" <br>
  Step e) Press on Comment button <br>
  Step f) Wait for the issue to be assigned to you. <br>
  Step g) After the issue get assigned to you. <br>
          You'll also receive my comment stating in which folder the solution needs to be placed as well as the deadline for solution submission. <br>
  Step h) Now you can workout the solution and generate PR(Pull request)
  
#### 3) Add a question
##### *provided question has been addressed earlier, so kindly go through the repository before raising an issue for a question.
- Steps - <br>
  Step a) Click on Issues tab <br>
  Step b) Click on New Issue button <br>
  Step c) Click Get Started button <br>
  Step d) Fill a short description form <br>
  Step e) Press Submit New Issue button <br>
  
 ### NOTE - Adding question and/or solution of any ongoing live challenges may lead to permanent ban from repository

<br>
In general, we follow the "fork-and-pull" Git workflow.

 1. **Fork** the repo on GitHub
 2. **Clone** the project to your own machine
 3. **Commit** changes to your own branch
 4. **Push** your work back up to your fork
 5. Submit a **Pull request** so that we can review your changes

NOTE: Be sure to merge the latest from "upstream" before making a pull request!


### Issues

Feel free to submit issues and enhancement requests.

Issues are very valuable to this project.

* Ideas are a valuable source of contributions others can make
* Problems show where this project is lacking
* With a question you show where contributors can improve the user experience


### Pull Requests

Pull requests are, a great way to get your ideas into this repository.

When deciding if I merge in a pull request I look at the following things:


#### Does it state intent

You should be clear which problem you're trying to solve with your contribution.

For example:

> Add a code for Arrays

Doesn't tell me anything about why you're doing that

> Add a code for Arrays
> > Question: Sum of numbers in an array(taking input for user)

Tells me the problem that you have found, and the pull request shows me the action you have taken to solve it.


#### Is it of good quality

* There are no spelling mistakes
* It reads well


#### Does it move this repository closer to my vision for the repository

The aim of this repository is:

* To provide a simple implementaions of codes with time complexites on the go, anyone can copy and paste, into their project
* The content is usable by someone who hasn't written something like this before
* Foster a culture of respect and gratitude in the open source community.


## 🌟 Contributors

Thanks to these wonderful peoples ✨✨:

<a href="https://github.com/SarthakKeshari/CPP-Questions-and-Solutions/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=SarthakKeshari/CPP-Questions-and-Solutions" />
</a>

